<template>
  <div class="about">
    <h1>Enter the name of a mod!</h1>
    <div>
    <form id="downloads">
      <p>
      <input type="text" 
      v-model="modName" 
      class="mod-input" 
      style="width: 335px; height: 30px;" 
      @focus="handleInputFocus"
      @input="handleInput">
      
    </p>
      <button @click.prevent="handleButtonClick">Search!</button>
    </form>
  </div>
  <div v-if="buttonClicked && responseGood" style="margin-top: 20px;">
    <p><img :src=modData.icon_url alt="The mod's cool icon."
      style="width:50px; height:50px;"></p>
    The amount of downloads {{ modData.title }} has is: {{ modData.downloads }}!
  </div>
  <div v-else-if="buttonClicked && modName === ``" style="margin-top: 20px;">
    Try typing something in!
  </div>
  <div v-else-if="buttonClicked && responseGood === false" style="margin-top: 20px;" > 
  We couldn't find {{ modName }}
  <br />
Try again!
  </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      modName: '',
      modifiedModName: "",
      buttonClicked: false,
      responseGood: null,
      modData: null,
    };
  },
  methods: {
    async handleButtonClick() {
      this.$emit('submit', this.modName);
      this.buttonClicked = true;
      this.modifiedModName = this.modName.trim().replace(/ /g, "-");
      try {
      const response = await window.fetch(`https://api.modrinth.com/v2/project/${this.modifiedModName}`,{
        method: 'GET'
      });

      if (response.ok){
      const data = await response.json();
      this.modData = data;
      this.responseGood = true;
      }
      else{
        this.responseGood = false;
      }

    }
    catch (error){
      console.error('error', error.message)
    }
    },

    handleInputFocus(){
      this.buttonClicked = false;
      this.responseGood = null;
      this.modData = null;
    },
    handleInput() {
      if (this.modName !== '' && this.buttonClicked) {
        this.buttonClicked = false;
        this.responseGood = null;
        this.modData = null;
      }
    }

}
}
</script>

<style>

  .about {
    align-items: center;
  }
.mod-input {
  display: block; 
  align-items: center;
  margin: 10px 0; 
}
button{
  position:relative;
  height: 35px;
  width: 120px;
  margin: 0 0px;
  font-size: 18px;
  font-weight: 500;
  letter-spacing: 1px;
  border-radius: 5px;
  text-transform: uppercase;
  border: 1px solid transparent;
  outline: none;
  cursor: pointer;
  background: #0d0d0d;
  overflow: hidden;
  transition: 0.6s;
}
button:first-child{
  color: #1BD96A;
  border-color: #1BD96A;
}
button:last-child{
  color: #188344;
  border-color: #1BD96A;
}
button:before, button:after{
  position: absolute;
  content: '';
  left: 0;
  top: 0;
  height: 100%;
  filter: blur(30px);
  opacity: 0.4;
  transition: 0.6s;
}
button:before{
  width: 60px;
  background: rgba(255,255,255,0.6);
  transform: translateX(-130px) skewX(-45deg);
}
button:after{
  width: 30px;
  background: rgba(255,255,255,0.6);
  transform: translateX(-130px) skewX(-45deg);
}
button:hover:before,
button:hover:after{
  opacity: 0.6;
  transform: translateX(320px) skewX(-45deg);
}
button:hover{
  color: #1BD96A;
}
button:hover:first-child{
  background: #1BD96A;
}
button:hover:last-child{
  background: #063a1c;
}
</style>
